import { Telegraf } from "telegraf";
import { message } from "telegraf/filters";

import config from "./config";
import { minky } from "./commands/minky";
import { Command } from "./utils/types";
import { forgejoDown } from "./commands/forgejo-down";
import { source } from "./commands/source";
import { sql } from "./commands/sql";
import { help } from "./commands/help";
import { moderateMessage } from "./modules/moderate";
import { howgay } from "./commands/howgay";

export const commands: Command[] = [forgejoDown, minky, source, sql, help, howgay];
export const bot = new Telegraf(config.token);

bot.on(message("text"), async (ctx) => {
    const msg = ctx.message;
    await moderateMessage(ctx);
    const author = await ctx.getChatMember(msg.from.id);
    config.prefixes.forEach((p) => {
        if (msg.text[0] !== p) return;
    });
    const rawArgs = msg.text.split(" ");
    let handled = false;
    try {
        commands.forEach(async (c) => {
            if (handled) return;
            if (c.name === rawArgs[0].replace("v", "") || `/${c.name}@vc_venbot` === rawArgs[0]) {
                if (
                    c.modOnly &&
                    author.status !== "administrator" &&
                    c.modOnly &&
                    author.status !== "creator"
                )
                    return await ctx.reply("💢 You can't do this!");
                if (c.ownerOnly && msg.from.id !== 1911826384)
                    return await ctx.reply("💢 You can't do this!");
                handled = true;
                rawArgs.splice(0, 1);
                c.handler(ctx, rawArgs);
            }
            c.aliases.forEach(async (a) => {
                if (a === rawArgs[0].replace("v", "") || `/${a}@vc_venbot` === rawArgs[0]) {
                    if (
                        c.modOnly &&
                        author.status !== "administrator" &&
                        c.modOnly &&
                        author.status !== "creator"
                    )
                        return await ctx.reply("💢 You can't do this!");
                    if (c.ownerOnly && msg.from.id !== 1911826384)
                        return await ctx.reply("💢 You can't do this!");
                    handled = true;
                    rawArgs.splice(0, 1);
                    c.handler(ctx, rawArgs);
                }
            });
        });
    } catch (c) {}
});

process.on("uncaughtException", (e) => {});

process.on("unhandledRejection", (e) => {});
