import { Context } from "telegraf";
import { Command, CommandTypes } from "../utils/types";
import { read } from "../utils/database";

async function handler(ctx: Context, args: string[]) {
    try {
        const result = await read(args.join(" "), []);
        const response = await fetch("https://bin.nin0.dev", {
            method: "POST",
            body: JSON.stringify({
                text: `${result}`,
                extension: "json"
            }),
            headers: new Headers({ "content-type": "application/json" })
        });
        if (!response.ok) {
            return ctx.reply("Couldn't upload to wastebin :(");
        }
        const jsonResponse = await response.json();
        ctx.reply(`See query result at https://bin.nin0.dev${jsonResponse.path}`);
    } catch (err) {
        ctx.reply("Error reading from database or uploading to wastebin :(");
    }
}

export const sql: Command = {
    name: "sql",
    description: "Eval a SQL query",
    type: CommandTypes.Utility,
    modOnly: false,
    ownerOnly: true,
    handler,
    aliases: []
};
