import { message } from "telegraf/filters";
import { bot } from "../client";
import { Context } from "telegraf";

const automoddedWords = ["meow", "miau", "mreow", "mrow", "mrrp", "mrrrp", "mrrrrp", "nya", "nyaa"];
const automoddedRegexes = ["mr*eo*w+", "mr+p", "nya+", "mrow+", "purr+"];

export async function moderateMessage(ctx: Context) {
    const author = await ctx.getChatMember(ctx.from.id);
    if (author.status === "administrator" || author.status === "creator") return;
    if (
        automoddedWords.some((word) => ctx.text.includes(word)) ||
        automoddedRegexes.some((pattern) => new RegExp(pattern, "i").test(ctx.text))
    ) {
        await ctx.deleteMessage();
        await ctx.restrictChatMember(ctx.from.id, {
            until_date: Math.floor(Date.now() / 1000) + 60,
            permissions: {
                can_send_messages: false,
                can_send_audios: false,
                can_send_documents: false,
                can_send_photos: false,
                can_send_videos: false,
                can_send_video_notes: false,
                can_send_voice_notes: false,
                can_send_other_messages: false,
                can_invite_users: false
            }
        });
        await ctx.reply(`Muted ${ctx.from.first_name} for 1 minute for using an automodded word.`);
    }
}
