import { Database } from "sqlite3";

const db = new Database("database.db");

export async function write(query: string, args: string[]): Promise<boolean> {
    return new Promise((resolve, reject) => {
        db.serialize(() => {
            db.run(query, args, (err) => {
                if (err) {
                    reject(err);
                } else {
                    resolve(true);
                }
            });
        });
    });
}

export async function read(query: string, args: string[]): Promise<string> {
    return new Promise((resolve, reject) => {
        db.serialize(() => {
            db.all(query, args, (err, rows) => {
                if (err) {
                    reject(err);
                } else {
                    resolve(JSON.stringify(rows));
                }
            });
        });
    });
}
